//+------------------------------------------------------------------+
//|                                   RSI_2PX_15M_NR_COLOR.mq4 
//+------------------------------------------------------------------+
#property copyright "AHGduP"
#property link      "RSI_2PX_15M_NR_COLOR"

#property indicator_separate_window
#property indicator_buffers 5
#property indicator_color1 Red
#property indicator_width1 2
#property indicator_color2 Gold  //DarkGray
#property indicator_width2 2
#property indicator_color3 DeepSkyBlue
#property indicator_width3 2
#property indicator_color4 LimeGreen // Lime
#property indicator_width4 2
#property indicator_color5 Yellow//Tan
#property indicator_width5 1
//#property indicator_maximum 100
//#property indicator_minimum 0

//=================================================================================================
#property indicator_level1 225
#property indicator_level2 190//LEVEL 3
#property indicator_level3 100//2
#property indicator_level4 20
#property indicator_level5 10

#property indicator_levelcolor C'160,160,160'   //DarkGray  
#property indicator_levelstyle STYLE_DOT
#property indicator_levelwidth 0

extern string     Input4             = "== RSI===";
extern int        RSI_Per_L          = 8 ;
extern int        RSI_Per_S          = 4 ;

extern int        TF                 = 5 ;    
extern bool       NoName             = true ;
extern bool       ShowDots           = false ;

extern int        LineSize           = 2;
extern int        DotSize            = 1;//0
extern int        CountBars          = 300; 

double RSIBuffer1[];
double RSIBuffer2[];
double RSIBuffer3[];
double RSIBuffer4[];
double RSIBuffer5[];
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
int init()
  {
    IndicatorDigits(+2);
    SetIndexStyle (0, DRAW_LINE, STYLE_SOLID, LineSize);
    SetIndexBuffer(0, RSIBuffer1);
    
    SetIndexStyle (3, DRAW_LINE, STYLE_SOLID, LineSize);
    SetIndexBuffer(3, RSIBuffer5);
    SetIndexStyle (2, DRAW_LINE, STYLE_SOLID, LineSize);
    SetIndexBuffer(2, RSIBuffer4);
    SetIndexStyle (1, DRAW_LINE, STYLE_SOLID, LineSize);
    SetIndexBuffer(1, RSIBuffer2);
   
    SetIndexStyle(4,DRAW_ARROW, STYLE_SOLID,  DotSize);
    SetIndexArrow(4,159);
    SetIndexBuffer(4,RSIBuffer3);
    
//========================================================================================    
      switch(TF)
   {  case 1 : string TimeFrameStr="Period_M1"; break;
      case 5 : TimeFrameStr="Period_M5"; break;
      case 15 : TimeFrameStr="Period_M15"; break;
      case 30 : TimeFrameStr="Period_M30"; break;
      case 60 : TimeFrameStr="Period_H1"; break;
      case 240 : TimeFrameStr="Period_H4"; break;
      case 1440 : TimeFrameStr="Period_D1"; break;
      case 10080 : TimeFrameStr="Period_W1"; break;
      case 43200 : TimeFrameStr="Period_MN1"; break;
      default : TimeFrameStr="Current Timeframe";
   } }
   return(0); 
//+---------------------------------------------------------------------------------------+
//+---------------------------------------------------------------------------------------+
int start()
  {  double   RSI_SHORT, RSI_LONG ;
     datetime TimeArray[];
     int    i,limit,y=0,counted_bars=IndicatorCounted();
     int    RSIShortPer=0,RSILongPer=0;
     ArrayCopySeries(TimeArray,MODE_TIME,Symbol(),TF); 
   
    limit=Bars-counted_bars;
    if(counted_bars>0) limit++; else if (limit>100) limit=CountBars;  
    
//====================================================================================================          
   for(i=0,y=0;i<limit;i++)
   {
   if (Time[i]<TimeArray[y]) y++;
//=========================================================================================
          RSIBuffer1[i] = (   (iRSI(NULL, TF, RSI_Per_L,  PRICE_CLOSE, y ))
         + (iRSI(NULL, TF, RSI_Per_L,  PRICE_CLOSE, y+1 )) 
                            + (iRSI(NULL, TF, RSI_Per_L, PRICE_CLOSE, y+2))  /3) ;    
         
          RSIBuffer3[i] = (  (iRSI(NULL, TF, RSI_Per_S, PRICE_CLOSE, y  )) 
         + (iRSI(NULL, TF, RSI_Per_S, PRICE_CLOSE, y+1  )) 
                           + (iRSI(NULL, TF, RSI_Per_S, PRICE_CLOSE, y+2))   /3) ;    
 
//========== COLOR CODING ==================================================================               
       
       RSIBuffer5[i] = RSIBuffer3[i];
       RSIBuffer4[i] = RSIBuffer3[i];
       RSIBuffer2[i] = RSIBuffer3[i]; 
       
       if      (  RSIBuffer3[i] > RSIBuffer1[i] )
               {  RSIBuffer4[i] = EMPTY_VALUE;  }
       else if (  RSIBuffer3[i] < RSIBuffer1[i] ) 
               {  RSIBuffer5[i] = EMPTY_VALUE;  }
       else    {  RSIBuffer2[i]=EMPTY_VALUE;
                  RSIBuffer5[i]=EMPTY_VALUE;
               }
        
//==========================================================================================
   if  ( NoName == true  )
       {   string  ThisName = "(5M_TT)";
           string Text=ThisName;
            Text=Text+"("+TF;
            Text=Text+")";
           IndicatorShortName(Text); 
           SetIndexLabel(0,"1");
            SetIndexLabel(1,"");
      }    
//====================================== 
if  ( NoName == false  )
{
        string  ThisName1 = "(5M_TT)";
        string Text1=ThisName1;
        Text1=Text1+"  ("+TF;
        Text1=Text1+")";
        Text1=Text1+"(";
        Text1=Text1+" "+DoubleToStr(RSI_Per_L,0);
        Text1=Text1+"/"+DoubleToStr(RSI_Per_S,0);
        Text1=Text1+")  ";
        IndicatorShortName(Text1); 
        SetIndexLabel(0,"(5M_TT)");
}       
//=========================================================================================       
  }    
   return(0);
  }

